OBJDIR := $(BUILD_TYPE)-$(PLATFORM)

# ------------------------------------------------------------------


TARGET_OBJS := \
	$(OBJDIR)/json.o \
	$(OBJDIR)/rstring.o \
	$(OBJDIR)/json_helper.o 


TARGET := $(OBJDIR)/libmjson.so

# ------------------------------------------------------------------

ifeq ("$(BUILD_TYPE)", "debug")
FLAGS_OPT := -O0 -g 
else
FLAGS_OPT := -O3
endif

LOCAL_CFLAGS := $(CFLAGS) -Wall -Werror $(FLAGS_OPT) -fno-strict-aliasing

LOCAL_LFLAGS := $(LDFLAGS) $(FLAGS_OPT) $(LIBS) 

# ------------------------------------------------------------------

all: setup $(TARGET)

setup:
	@mkdir -p $(OBJDIR)

$(TARGET): $(TARGET_OBJS)
	$(CXX) -shared -o $(TARGET) $(TARGET_OBJS) $(LOCAL_LFLAGS)
	
$(OBJDIR)/json.o : json.c
	$(CC) $(INCLUDES) $(LOCAL_CFLAGS) -c $< -o $@
$(OBJDIR)/rstring.o : rstring.c
	$(CC) $(INCLUDES) $(LOCAL_CFLAGS) -c $< -o $@
$(OBJDIR)/json_helper.o : json_helper.c
	$(CC) $(INCLUDES) $(LOCAL_CFLAGS) -c $< -o $@


clean:
	rm -rf $(OBJDIR)

